//+------------------------------------------------------------------+
//|                                    SpielersHedge Correlation.mq4 |
//|                                             2008.07.15 SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " 2008.07.15 SwingMan"
#property link      ""

#property indicator_separate_window

#property indicator_buffers 2
//---- colors
#property indicator_color1 DodgerBlue
#property indicator_color2 Magenta

//---- extern parameters --------------------------------------------
extern int     Period_Correlation         = 21;
extern string  _........SYMBOLS.........._="________________________________";
extern string  BaseSymbol                 = "EURUSD";
extern string  HedgeSymbol                = "USDCHF";
extern string  _.....TIME_FRAMES........._="________________________________";
extern int  	TimeFrame			         = 0; 
//------------------------------------------------------------------
#define Period_Trigger 21

//---- Moving Averages
double Correlation[];
double Trigger[];
//---- Arrays
double sdX[], sdY[], avgX[], avgY[];
//---- variables
string sWindow;
int TimeFrame1=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{   
   sWindow = "SpielersHedge Correlation (" + BaseSymbol + "--" + HedgeSymbol + "-- ";
   sWindow = sWindow + Period_Correlation;
   sWindow = sWindow + ") ";
   IndicatorShortName(sWindow);   
   
   ArraySetAsSeries(sdX, true); 
   ArraySetAsSeries(sdY, true);
   ArraySetAsSeries(avgX, true); 
   ArraySetAsSeries(avgY, true);     
  
//---- Moving Averages ----------------------------------  
   SetIndexBuffer(0,Correlation);
   SetIndexBuffer(1,Trigger);
   
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT,1);
   
   SetIndexLabel(0,"Correlation");
   SetIndexLabel(1,NULL);
   
//---- initialization done   
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{ return(0); }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   ArrayResize(sdX, Bars); 
   ArrayResize(sdY, Bars);
   ArrayResize(avgX, Bars); 
   ArrayResize(avgY, Bars); 

   int i, limit;  
   int counted_bars=IndicatorCounted();  
   if (counted_bars>0) counted_bars--;  
   limit=Bars - counted_bars;
   
//-- Moving average; StdDev
   for (i=0; i < limit; i++) {
      avgX[i] =     iMA(BaseSymbol,TimeFrame1,  Period_Correlation, 0, MODE_SMA, PRICE_CLOSE, i); 
      avgY[i] =     iMA(HedgeSymbol,TimeFrame1, Period_Correlation, 0, MODE_SMA, PRICE_CLOSE, i);   
      sdX[i]  = iStdDev(BaseSymbol,TimeFrame1,  Period_Correlation, 0, MODE_SMA, PRICE_CLOSE, i);
      sdY[i ] = iStdDev(HedgeSymbol,TimeFrame1, Period_Correlation, 0, MODE_SMA, PRICE_CLOSE, i);  
   }
      
//---- 1. Calculation ------------------------------------------------
   //-- Correlation
   for (i=0; i < limit; i++) {   
      double sum = 0;
      for (int Bar=0; Bar < Period_Correlation; Bar++) {
         if (sdX[i] != 0.0) double diffX = (iClose(BaseSymbol,TimeFrame1,i+Bar) - avgX[i]) / sdX[i];
         if (sdY[i] != 0.0) double diffY = (iClose(HedgeSymbol,TimeFrame1,i+Bar) - avgY[i]) / sdY[i];
         sum = sum + diffX * diffY;         
      }
      Correlation[i] = sum / Period_Correlation;
   }

   //-- Trigger
   for (i=0; i < limit; i++) {
      Trigger[i] = iMAOnArray(Correlation,0,Period_Trigger,0,MODE_SMA,i); 
   }

//----
   return(0);
}
//+------------------------------------------------------------------+

