//+------------------------------------------------------------------+
//|                                   SpielersHedge oClosePrices.mq4 |
//|                                            2008.07.13, SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " 2008.07.13, SwingMan"
#property link      ""

#property indicator_separate_window

#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Green

//---- inputs --------------------------------------------------------
extern string Pair1 = "WTI";
extern string Pair2 = "BRN";
extern bool CalcWithShiftBar = true;
//--------------------------------------------------------------------

double Line1[], Line2[];

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int init()
{
   if (Pair2 == Symbol()) {
      string tempPair = Pair1;
      Pair1 = Pair2;
      Pair2 = tempPair;
   }
   
   SetIndexBuffer(0,Line1); SetIndexLabel(0,"Close "+ Pair1); SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,Line2); SetIndexLabel(1,"Close "+ Pair2); SetIndexStyle(1,DRAW_LINE);

   string st = "SpielersHedge oClosePrices   ("+Pair1+"--"+Pair2+") ";
   IndicatorShortName(st);
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int deinit()
{
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int start() 
{  
   int counted_bars = IndicatorCounted();
   int i, limit;
   
   if (counted_bars < 0) return(-1);
   if (counted_bars > 0) counted_bars--;
   limit=Bars - counted_bars;

   if (CalcWithShiftBar)
   for (i=0; i<limit; i++)
   {  
      datetime dDateTime1 = iTime(Pair1, Period(), i);
      int iBar2 = iBarShift(Pair2, Period(), dDateTime1);
      Line1[i] = iClose(Pair1, 0, i);
      Line2[i] = iClose(Pair2, 0, iBar2);
   }
   else
   for (i=0; i<limit; i++)
   {  
      Line1[i] = iClose(Pair1, 0, i);
      Line2[i] = iClose(Pair2, 0, i);
   }
   return(0);
}